diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/theme-install.php ./wordpress-3.4/wp-admin/includes/theme-install.php
*** ./wordpress-3.3.2/wp-admin/includes/theme-install.php	2011-10-20 10:04:46.000000000 -0500
--- ./wordpress-3.4/wp-admin/includes/theme-install.php	2012-05-16 18:38:53.000000000 -0500
***************
*** 24,38 ****
   *
   * @since 2.8.0
   *
!  * @deprecated since 3.1.0  Use get_theme_feature_list() instead.
   *
   * @return array
   */
  function install_themes_feature_list( ) {
  	if ( !$cache = get_transient( 'wporg_theme_feature_list' ) )
! 		set_transient( 'wporg_theme_feature_list', array( ),  10800);
  
! 	if ( $cache  )
  		return $cache;
  
  	$feature_list = themes_api( 'feature_list', array( ) );
--- 24,38 ----
   *
   * @since 2.8.0
   *
!  * @deprecated since 3.1.0 Use get_theme_feature_list() instead.
   *
   * @return array
   */
  function install_themes_feature_list( ) {
  	if ( !$cache = get_transient( 'wporg_theme_feature_list' ) )
! 		set_transient( 'wporg_theme_feature_list', array( ), 10800);
  
! 	if ( $cache )
  		return $cache;
  
  	$feature_list = themes_api( 'feature_list', array( ) );
***************
*** 49,68 ****
   *
   * @since 2.8.0
   */
! function install_theme_search_form() {
! 	$type = isset( $_REQUEST['type'] ) ? stripslashes( $_REQUEST['type'] ) : '';
  	$term = isset( $_REQUEST['s'] ) ? stripslashes( $_REQUEST['s'] ) : '';
  	?>
- <p class="install-help"><?php _e('Search for themes by keyword, author, or tag.') ?></p>
- 
  <form id="search-themes" method="get" action="">
  	<input type="hidden" name="tab" value="search" />
  	<select	name="type" id="typeselector">
! 	<option value="term" <?php selected('term', $type) ?>><?php _e('Term'); ?></option>
  	<option value="author" <?php selected('author', $type) ?>><?php _e('Author'); ?></option>
  	<option value="tag" <?php selected('tag', $type) ?>><?php _ex('Tag', 'Theme Installer'); ?></option>
  	</select>
! 	<input type="text" name="s" size="30" value="<?php echo esc_attr($term) ?>" />
  	<?php submit_button( __( 'Search' ), 'button', 'search', false ); ?>
  </form>
  <?php
--- 49,70 ----
   *
   * @since 2.8.0
   */
! function install_theme_search_form( $type_selector = true ) {
! 	$type = isset( $_REQUEST['type'] ) ? stripslashes( $_REQUEST['type'] ) : 'term';
  	$term = isset( $_REQUEST['s'] ) ? stripslashes( $_REQUEST['s'] ) : '';
+ 	if ( ! $type_selector )
+ 		echo '<p class="install-help">' . __( 'Search for themes by keyword.' ) . '</p>';
  	?>
  <form id="search-themes" method="get" action="">
  	<input type="hidden" name="tab" value="search" />
+ 	<?php if ( $type_selector ) : ?>
  	<select	name="type" id="typeselector">
! 	<option value="term" <?php selected('term', $type) ?>><?php _e('Keyword'); ?></option>
  	<option value="author" <?php selected('author', $type) ?>><?php _e('Author'); ?></option>
  	<option value="tag" <?php selected('tag', $type) ?>><?php _ex('Tag', 'Theme Installer'); ?></option>
  	</select>
! 	<?php endif; ?>
! 	<input type="search" name="s" size="30" value="<?php echo esc_attr($term) ?>" />
  	<?php submit_button( __( 'Search' ), 'button', 'search', false ); ?>
  </form>
  <?php
***************
*** 74,84 ****
   * @since 2.8.0
   */
  function install_themes_dashboard() {
! 	install_theme_search_form();
  ?>
  <h4><?php _e('Feature Filter') ?></h4>
! <form method="post" action="<?php echo self_admin_url( 'theme-install.php?tab=search' ); ?>">
! <p class="install-help"><?php _e('Find a theme based on specific features') ?></p>
  	<?php
  	$feature_list = get_theme_feature_list( );
  	echo '<div class="feature-filter">';
--- 76,88 ----
   * @since 2.8.0
   */
  function install_themes_dashboard() {
! 	install_theme_search_form( false );
  ?>
  <h4><?php _e('Feature Filter') ?></h4>
! <p class="install-help"><?php _e( 'Find a theme based on specific features.' ); ?></p>
! 
! <form method="get" action="">
! 	<input type="hidden" name="tab" value="search" />
  	<?php
  	$feature_list = get_theme_feature_list( );
  	echo '<div class="feature-filter">';
***************
*** 94,100 ****
  ?>
  
  <li>
! 	<input type="checkbox" name="features[<?php echo $feature; ?>]" id="feature-id-<?php echo $feature; ?>" value="<?php echo $feature; ?>" />
  	<label for="feature-id-<?php echo $feature; ?>"><?php echo $feature_name; ?></label>
  </li>
  
--- 98,104 ----
  ?>
  
  <li>
! 	<input type="checkbox" name="features[]" id="feature-id-<?php echo $feature; ?>" value="<?php echo $feature; ?>" />
  	<label for="feature-id-<?php echo $feature; ?>"><?php echo $feature_name; ?></label>
  </li>
  
***************
*** 125,199 ****
  }
  add_action('install_themes_upload', 'install_themes_upload', 10, 1);
  
! function display_theme($theme, $actions = null, $show_details = true) {
! 	global $themes_allowedtags;
! 
! 	if ( empty($theme) )
! 		return;
! 
! 	$name = wp_kses($theme->name, $themes_allowedtags);
! 	$desc = wp_kses($theme->description, $themes_allowedtags);
! 	//if ( strlen($desc) > 30 )
! 	//	$desc =  substr($desc, 0, 15) . '<span class="dots">...</span><span>' . substr($desc, -15) . '</span>';
! 
! 	$preview_link = $theme->preview_url . '?TB_iframe=true&amp;width=600&amp;height=400';
! 	if ( !is_array($actions) ) {
! 		$actions = array();
! 		$actions[] = '<a href="' . self_admin_url('theme-install.php?tab=theme-information&amp;theme=' . $theme->slug .
! 										'&amp;TB_iframe=true&amp;tbWidth=500&amp;tbHeight=385') . '" class="thickbox thickbox-preview onclick" title="' . esc_attr(sprintf(__('Install &#8220;%s&#8221;'), $name)) . '">' . __('Install') . '</a>';
! 		if ( !is_network_admin() )
! 			$actions[] = '<a href="' . $preview_link . '" class="thickbox thickbox-preview onclick previewlink" title="' . esc_attr(sprintf(__('Preview &#8220;%s&#8221;'), $name)) . '">' . __('Preview') . '</a>';
! 		$actions = apply_filters('theme_install_action_links', $actions, $theme);
! 	}
! 
! 	$actions = implode ( ' | ', $actions );
! 	?>
! <a class='thickbox thickbox-preview screenshot'
! 	href='<?php echo esc_url($preview_link); ?>'
! 	title='<?php echo esc_attr(sprintf(__('Preview &#8220;%s&#8221;'), $name)); ?>'>
! <img src='<?php echo esc_url($theme->screenshot_url); ?>' width='150' />
! </a>
! <h3><?php echo $name ?></h3>
! <span class='action-links'><?php echo $actions ?></span>
! <p><?php echo $desc ?></p>
! <?php if ( $show_details ) { ?>
! <a href="#theme_detail" class="theme-detail hide-if-no-js" tabindex='4'><?php _e('Details') ?></a>
! <div class="themedetaildiv hide-if-js">
! <p><strong><?php _e('Version:') ?></strong> <?php echo wp_kses($theme->version, $themes_allowedtags) ?></p>
! <p><strong><?php _e('Author:') ?></strong> <?php echo wp_kses($theme->author, $themes_allowedtags) ?></p>
! <?php if ( ! empty($theme->last_updated) ) : ?>
! <p><strong><?php _e('Last Updated:') ?></strong> <span title="<?php echo $theme->last_updated ?>"><?php printf( __('%s ago'), human_time_diff(strtotime($theme->last_updated)) ) ?></span></p>
! <?php endif; if ( ! empty($theme->requires) ) : ?>
! <p><strong><?php _e('Requires WordPress Version:') ?></strong> <?php printf(__('%s or higher'), $theme->requires) ?></p>
! <?php endif; if ( ! empty($theme->tested) ) : ?>
! <p><strong><?php _e('Compatible up to:') ?></strong> <?php echo $theme->tested ?></p>
! <?php endif; if ( !empty($theme->downloaded) ) : ?>
! <p><strong><?php _e('Downloaded:') ?></strong> <?php printf(_n('%s time', '%s times', $theme->downloaded), number_format_i18n($theme->downloaded)) ?></p>
! <?php endif; ?>
! <div class="star-holder" title="<?php printf(_n('(based on %s rating)', '(based on %s ratings)', $theme->num_ratings), number_format_i18n($theme->num_ratings)) ?>">
! 	<div class="star star-rating" style="width: <?php echo esc_attr($theme->rating) ?>px"></div>
! 	<div class="star star5"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('5 stars') ?>" /></div>
! 	<div class="star star4"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('4 stars') ?>" /></div>
! 	<div class="star star3"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('3 stars') ?>" /></div>
! 	<div class="star star2"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('2 stars') ?>" /></div>
! 	<div class="star star1"><img src="<?php echo admin_url('images/star.png?v=20110615'); ?>" alt="<?php esc_attr_e('1 star') ?>" /></div>
! </div>
! </div>
! <?php }
! 	/*
! 	 object(stdClass)[59]
! 	 public 'name' => string 'Magazine Basic' (length=14)
! 	 public 'slug' => string 'magazine-basic' (length=14)
! 	 public 'version' => string '1.1' (length=3)
! 	 public 'author' => string 'tinkerpriest' (length=12)
! 	 public 'preview_url' => string 'http://wp-themes.com/?magazine-basic' (length=36)
! 	 public 'screenshot_url' => string 'http://wp-themes.com/wp-content/themes/magazine-basic/screenshot.png' (length=68)
! 	 public 'rating' => float 80
! 	 public 'num_ratings' => int 1
! 	 public 'homepage' => string 'http://wordpress.org/extend/themes/magazine-basic' (length=49)
! 	 public 'description' => string 'A basic magazine style layout with a fully customizable layout through a backend interface. Designed by <a href="http://bavotasan.com">c.bavota</a> of <a href="http://tinkerpriestmedia.com">Tinker Priest Media</a>.' (length=214)
! 	 public 'download_link' => string 'http://wordpress.org/extend/themes/download/magazine-basic.1.1.zip' (length=66)
! 	 */
  }
  
  /**
--- 129,143 ----
  }
  add_action('install_themes_upload', 'install_themes_upload', 10, 1);
  
! /**
!  * Prints a theme on the Install Themes pages.
!  *
!  * @deprecated 3.4.0
!  */
! function display_theme( $theme ) {
! 	_deprecated_function( __FUNCTION__, '3.4' );
! 	global $wp_list_table;
! 	return $wp_list_table->single_row( $theme );
  }
  
  /**
***************
*** 217,321 ****
   * @since 2.8.0
   */
  function install_theme_information() {
! 	//TODO: This function needs a LOT of UI work :)
! 	global $tab, $themes_allowedtags;
! 
! 	$api = themes_api('theme_information', array('slug' => stripslashes( $_REQUEST['theme'] ) ));
  
! 	if ( is_wp_error($api) )
! 		wp_die($api);
  
! 	// Sanitize HTML
! 	foreach ( (array)$api->sections as $section_name => $content )
! 		$api->sections[$section_name] = wp_kses($content, $themes_allowedtags);
! 
! 	foreach ( array('version', 'author', 'requires', 'tested', 'homepage', 'downloaded', 'slug') as $key ) {
! 		if ( isset($api->$key) )
! 			$api->$key = wp_kses($api->$key, $themes_allowedtags);
! 	}
  
  	iframe_header( __('Theme Install') );
! 
! 	if ( empty($api->download_link) ) {
! 		echo '<div id="message" class="error"><p>' . __('<strong>ERROR:</strong> This theme is currently not available. Please try again later.') . '</p></div>';
! 		iframe_footer();
! 		exit;
! 	}
! 
! 	if ( !empty($api->tested) && version_compare($GLOBALS['wp_version'], $api->tested, '>') )
! 		echo '<div class="updated"><p>' . __('<strong>Warning:</strong> This theme has <strong>not been tested</strong> with your current version of WordPress.') . '</p></div>';
! 	else if ( !empty($api->requires) && version_compare($GLOBALS['wp_version'], $api->requires, '<') )
! 		echo '<div class="updated"><p>' . __('<strong>Warning:</strong> This theme has not been marked as <strong>compatible</strong> with your version of WordPress.') . '</p></div>';
! 
! 	// Default to a "new" theme
! 	$type = 'install';
! 	// Check to see if this theme is known to be installed, and has an update awaiting it.
! 	$update_themes = get_site_transient('update_themes');
! 	if ( is_object($update_themes) && isset($update_themes->response) ) {
! 		foreach ( (array)$update_themes->response as $theme_slug => $theme_info ) {
! 			if ( $theme_slug === $api->slug ) {
! 				$type = 'update_available';
! 				$update_file = $theme_slug;
! 				break;
! 			}
! 		}
! 	}
! 
! 	$themes = get_themes();
! 	foreach ( (array) $themes as $this_theme ) {
! 		if ( is_array($this_theme) && $this_theme['Stylesheet'] == $api->slug ) {
! 			if ( $this_theme['Version'] == $api->version ) {
! 				$type = 'latest_installed';
! 			} elseif ( $this_theme['Version'] > $api->version ) {
! 				$type = 'newer_installed';
! 				$newer_version = $this_theme['Version'];
! 			}
! 			break;
! 		}
! 	}
! ?>
! 
! <div class='available-theme'>
! <img src='<?php echo esc_url($api->screenshot_url) ?>' width='300' class="theme-preview-img" />
! <h3><?php echo $api->name; ?></h3>
! <p><?php printf(__('by %s'), $api->author); ?></p>
! <p><?php printf(__('Version: %s'), $api->version); ?></p>
! 
! <?php
! $buttons = '<a class="button" id="cancel" href="#" onclick="tb_close();return false;">' . __('Cancel') . '</a> ';
! 
! switch ( $type ) {
! default:
! case 'install':
! 	if ( current_user_can('install_themes') ) :
! 	$buttons .= '<a class="button-primary" id="install" href="' . wp_nonce_url(self_admin_url('update.php?action=install-theme&theme=' . $api->slug), 'install-theme_' . $api->slug) . '" target="_parent">' . __('Install Now') . '</a>';
! 	endif;
! 	break;
! case 'update_available':
! 	if ( current_user_can('update_themes') ) :
! 	$buttons .= '<a class="button-primary" id="install"	href="' . wp_nonce_url(self_admin_url('update.php?action=upgrade-theme&theme=' . $update_file), 'upgrade-theme_' . $update_file) . '" target="_parent">' . __('Install Update Now') . '</a>';
! 	endif;
! 	break;
! case 'newer_installed':
! 	if ( current_user_can('install_themes') || current_user_can('update_themes') ) :
! 	?><p><?php printf(__('Newer version (%s) is installed.'), $newer_version); ?></p><?php
! 	endif;
! 	break;
! case 'latest_installed':
! 	if ( current_user_can('install_themes') || current_user_can('update_themes') ) :
! 	?><p><?php _e('This version is already installed.'); ?></p><?php
! 	endif;
! 	break;
! } ?>
! <br class="clear" />
! </div>
! 
! <p class="action-button">
! <?php echo $buttons; ?>
! <br class="clear" />
! </p>
! 
! <?php
  	iframe_footer();
  	exit;
  }
--- 161,175 ----
   * @since 2.8.0
   */
  function install_theme_information() {
! 	global $tab, $themes_allowedtags, $wp_list_table;
  
! 	$theme = themes_api( 'theme_information', array( 'slug' => stripslashes( $_REQUEST['theme'] ) ) );
  
! 	if ( is_wp_error( $theme ) )
! 		wp_die( $theme );
  
  	iframe_header( __('Theme Install') );
! 	$wp_list_table->theme_installer_single( $theme );
  	iframe_footer();
  	exit;
  }
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-admin/includes/theme.php ./wordpress-3.4/wp-admin/includes/theme.php
*** ./wordpress-3.3.2/wp-admin/includes/theme.php	2011-11-11 08:10:54.000000000 -0600
--- ./wordpress-3.4/wp-admin/includes/theme.php	2012-06-06 15:34:24.000000000 -0500
***************
*** 7,69 ****
   */
  
  /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 2.0.0
-  *
-  * @return unknown
-  */
- function current_theme_info() {
- 	$themes = get_themes();
- 	$current_theme = get_current_theme();
- 
- 	if ( ! $themes ) {
- 		$ct = new stdClass;
- 		$ct->name = $current_theme;
- 		return $ct;
- 	}
- 
- 	if ( ! isset( $themes[$current_theme] ) ) {
- 		delete_option( 'current_theme' );
- 		$current_theme = get_current_theme();
- 	}
- 
- 	$ct = new stdClass;
- 	$ct->name = $current_theme;
- 	$ct->title = $themes[$current_theme]['Title'];
- 	$ct->version = $themes[$current_theme]['Version'];
- 	$ct->parent_theme = $themes[$current_theme]['Parent Theme'];
- 	$ct->template_dir = $themes[$current_theme]['Template Dir'];
- 	$ct->stylesheet_dir = $themes[$current_theme]['Stylesheet Dir'];
- 	$ct->template = $themes[$current_theme]['Template'];
- 	$ct->stylesheet = $themes[$current_theme]['Stylesheet'];
- 	$ct->screenshot = $themes[$current_theme]['Screenshot'];
- 	$ct->description = $themes[$current_theme]['Description'];
- 	$ct->author = $themes[$current_theme]['Author'];
- 	$ct->tags = $themes[$current_theme]['Tags'];
- 	$ct->theme_root = $themes[$current_theme]['Theme Root'];
- 	$ct->theme_root_uri = $themes[$current_theme]['Theme Root URI'];
- 	return $ct;
- }
- 
- /**
   * Remove a theme
   *
   * @since 2.8.0
   *
!  * @param string $template Template directory of the theme to delete
   * @param string $redirect Redirect to page when complete.
   * @return mixed
   */
! function delete_theme($template, $redirect = '') {
  	global $wp_filesystem;
  
! 	if ( empty($template) )
  		return false;
  
  	ob_start();
  	if ( empty( $redirect ) )
! 		$redirect = wp_nonce_url('themes.php?action=delete&template=' . $template, 'delete-theme_' . $template);
  	if ( false === ($credentials = request_filesystem_credentials($redirect)) ) {
  		$data = ob_get_contents();
  		ob_end_clean();
--- 7,29 ----
   */
  
  /**
   * Remove a theme
   *
   * @since 2.8.0
   *
!  * @param string $stylesheet Stylesheet of the theme to delete
   * @param string $redirect Redirect to page when complete.
   * @return mixed
   */
! function delete_theme($stylesheet, $redirect = '') {
  	global $wp_filesystem;
  
! 	if ( empty($stylesheet) )
  		return false;
  
  	ob_start();
  	if ( empty( $redirect ) )
! 		$redirect = wp_nonce_url('themes.php?action=delete&stylesheet=' . $stylesheet, 'delete-theme_' . $stylesheet);
  	if ( false === ($credentials = request_filesystem_credentials($redirect)) ) {
  		$data = ob_get_contents();
  		ob_end_clean();
***************
*** 102,112 ****
  		return new WP_Error('fs_no_themes_dir', __('Unable to locate WordPress theme directory.'));
  
  	$themes_dir = trailingslashit( $themes_dir );
! 	$theme_dir = trailingslashit($themes_dir . $template);
  	$deleted = $wp_filesystem->delete($theme_dir, true);
  
  	if ( ! $deleted )
! 		return new WP_Error('could_not_remove_theme', sprintf(__('Could not fully remove the theme %s.'), $template) );
  
  	// Force refresh of theme update information
  	delete_site_transient('update_themes');
--- 61,71 ----
  		return new WP_Error('fs_no_themes_dir', __('Unable to locate WordPress theme directory.'));
  
  	$themes_dir = trailingslashit( $themes_dir );
! 	$theme_dir = trailingslashit($themes_dir . $stylesheet);
  	$deleted = $wp_filesystem->delete($theme_dir, true);
  
  	if ( ! $deleted )
! 		return new WP_Error('could_not_remove_theme', sprintf(__('Could not fully remove the theme %s.'), $stylesheet) );
  
  	// Force refresh of theme update information
  	delete_site_transient('update_themes');
***************
*** 115,173 ****
  }
  
  /**
-  * {@internal Missing Short Description}}
-  *
-  * @since 1.5.0
-  *
-  * @return unknown
-  */
- function get_broken_themes() {
- 	global $wp_broken_themes;
- 
- 	get_themes();
- 	return $wp_broken_themes;
- }
- 
- /**
-  * Get the allowed themes for the current blog.
-  *
-  * @since 3.0.0
-  *
-  * @uses get_themes()
-  * @uses current_theme_info()
-  * @uses get_site_allowed_themes()
-  * @uses wpmu_get_blog_allowedthemes
-  *
-  * @return array $themes Array of allowed themes.
-  */
- function get_allowed_themes() {
- 	if ( !is_multisite() )
- 		return get_themes();
- 
- 	$themes = get_themes();
- 	$ct = current_theme_info();
- 	$allowed_themes = apply_filters("allowed_themes", get_site_allowed_themes() );
- 	if ( $allowed_themes == false )
- 		$allowed_themes = array();
- 
- 	$blog_allowed_themes = wpmu_get_blog_allowedthemes();
- 	if ( is_array( $blog_allowed_themes ) )
- 		$allowed_themes = array_merge( $allowed_themes, $blog_allowed_themes );
- 
- 	if ( isset( $allowed_themes[ esc_html( $ct->stylesheet ) ] ) == false )
- 		$allowed_themes[ esc_html( $ct->stylesheet ) ] = true;
- 
- 	reset( $themes );
- 	foreach ( $themes as $key => $theme ) {
- 		if ( isset( $allowed_themes[ esc_html( $theme[ 'Stylesheet' ] ) ] ) == false )
- 			unset( $themes[ $key ] );
- 	}
- 	reset( $themes );
- 
- 	return $themes;
- }
- 
- /**
   * Get the Page Templates available in this theme
   *
   * @since 1.5.0
--- 74,79 ----
***************
*** 175,211 ****
   * @return array Key is the template name, value is the filename of the template
   */
  function get_page_templates() {
! 	$themes = get_themes();
! 	$theme = get_current_theme();
! 	$templates = $themes[$theme]['Template Files'];
! 	$page_templates = array();
! 
! 	if ( is_array( $templates ) ) {
! 		$base = array( trailingslashit(get_template_directory()), trailingslashit(get_stylesheet_directory()) );
! 
! 		foreach ( $templates as $template ) {
! 			$basename = str_replace($base, '', $template);
! 
! 			// don't allow template files in subdirectories
! 			if ( false !== strpos($basename, '/') )
! 				continue;
! 
! 			if ( 'functions.php' == $basename )
! 				continue;
! 
! 			$template_data = implode( '', file( $template ));
! 
! 			$name = '';
! 			if ( preg_match( '|Template Name:(.*)$|mi', $template_data, $name ) )
! 				$name = _cleanup_header_comment($name[1]);
! 
! 			if ( !empty( $name ) ) {
! 				$page_templates[trim( $name )] = $basename;
! 			}
! 		}
! 	}
! 
! 	return $page_templates;
  }
  
  /**
--- 81,87 ----
   * @return array Key is the template name, value is the filename of the template
   */
  function get_page_templates() {
! 	return array_flip( wp_get_theme()->get_page_templates() );
  }
  
  /**
***************
*** 241,259 ****
  	if ( !isset($themes_update) )
  		$themes_update = get_site_transient('update_themes');
  
! 	if ( is_object($theme) && isset($theme->stylesheet) )
! 		$stylesheet = $theme->stylesheet;
! 	elseif ( is_array($theme) && isset($theme['Stylesheet']) )
! 		$stylesheet = $theme['Stylesheet'];
! 	else
! 		return false; //No valid info passed.
  
  	if ( isset($themes_update->response[ $stylesheet ]) ) {
  		$update = $themes_update->response[ $stylesheet ];
! 		$theme_name = is_object($theme) ? $theme->name : (is_array($theme) ? $theme['Name'] : '');
  		$details_url = add_query_arg(array('TB_iframe' => 'true', 'width' => 1024, 'height' => 800), $update['url']); //Theme browser inside WP? replace this, Also, theme preview JS will override this on the available list.
  		$update_url = wp_nonce_url('update.php?action=upgrade-theme&amp;theme=' . urlencode($stylesheet), 'upgrade-theme_' . $stylesheet);
! 		$update_onclick = 'onclick="if ( confirm(\'' . esc_js( __("Updating this theme will lose any customizations you have made.  'Cancel' to stop, 'OK' to update.") ) . '\') ) {return true;}return false;"';
  
  		if ( !is_multisite() ) {
  			if ( ! current_user_can('update_themes') )
--- 117,133 ----
  	if ( !isset($themes_update) )
  		$themes_update = get_site_transient('update_themes');
  
! 	if ( ! is_a( $theme, 'WP_Theme' ) )
! 		return;
! 
! 	$stylesheet = $theme->get_stylesheet();
  
  	if ( isset($themes_update->response[ $stylesheet ]) ) {
  		$update = $themes_update->response[ $stylesheet ];
! 		$theme_name = $theme->display('Name');
  		$details_url = add_query_arg(array('TB_iframe' => 'true', 'width' => 1024, 'height' => 800), $update['url']); //Theme browser inside WP? replace this, Also, theme preview JS will override this on the available list.
  		$update_url = wp_nonce_url('update.php?action=upgrade-theme&amp;theme=' . urlencode($stylesheet), 'upgrade-theme_' . $stylesheet);
! 		$update_onclick = 'onclick="if ( confirm(\'' . esc_js( __("Updating this theme will lose any customizations you have made. 'Cancel' to stop, 'OK' to update.") ) . '\') ) {return true;}return false;"';
  
  		if ( !is_multisite() ) {
  			if ( ! current_user_can('update_themes') )
***************
*** 261,267 ****
  			else if ( empty($update['package']) )
  				printf( '<p><strong>' . __('There is a new version of %1$s available. <a href="%2$s" class="thickbox" title="%1$s">View version %3$s details</a>. <em>Automatic update is unavailable for this theme.</em>') . '</strong></p>', $theme_name, $details_url, $update['new_version']);
  			else
! 				printf( '<p><strong>' . __('There is a new version of %1$s available. <a href="%2$s" class="thickbox" title="%1$s">View version %3$s details</a> or <a href="%4$s" %5$s>update automatically</a>.') . '</strong></p>', $theme_name, $details_url, $update['new_version'], $update_url, $update_onclick );
  		}
  	}
  }
--- 135,141 ----
  			else if ( empty($update['package']) )
  				printf( '<p><strong>' . __('There is a new version of %1$s available. <a href="%2$s" class="thickbox" title="%1$s">View version %3$s details</a>. <em>Automatic update is unavailable for this theme.</em>') . '</strong></p>', $theme_name, $details_url, $update['new_version']);
  			else
! 				printf( '<p><strong>' . __('There is a new version of %1$s available. <a href="%2$s" class="thickbox" title="%1$s">View version %3$s details</a> or <a href="%4$s" %5$s>update now</a>.') . '</strong></p>', $theme_name, $details_url, $update['new_version'], $update_url, $update_onclick );
  		}
  	}
  }
***************
*** 271,279 ****
   *
   * @since 3.1.0
   *
!  * @return array  Array of features keyed by category with translations keyed by slug.
   */
! function get_theme_feature_list() {
  	// Hard-coded list is used if api not accessible.
  	$features = array(
  			__('Colors') => array(
--- 145,154 ----
   *
   * @since 3.1.0
   *
!  * @param bool $api Optional. Whether try to fetch tags from the WP.org API. Defaults to true.
!  * @return array Array of features keyed by category with translations keyed by slug.
   */
! function get_theme_feature_list( $api = true ) {
  	// Hard-coded list is used if api not accessible.
  	$features = array(
  			__('Colors') => array(
***************
*** 291,297 ****
  				'white'   => __( 'White' ),
  				'yellow'  => __( 'Yellow' ),
  				'dark'    => __( 'Dark' ),
! 				'light'   => __( 'Light ')
  			),
  
  		__('Columns') => array(
--- 166,172 ----
  				'white'   => __( 'White' ),
  				'yellow'  => __( 'Yellow' ),
  				'dark'    => __( 'Dark' ),
! 				'light'   => __( 'Light' ),
  			),
  
  		__('Columns') => array(
***************
*** 300,311 ****
  			'three-columns' => __( 'Three Columns' ),
  			'four-columns'  => __( 'Four Columns' ),
  			'left-sidebar'  => __( 'Left Sidebar' ),
! 			'right-sidebar' => __( 'Right Sidebar' )
  		),
  
  		__('Width') => array(
  			'fixed-width'    => __( 'Fixed Width' ),
! 			'flexible-width' => __( 'Flexible Width' )
  		),
  
  		__( 'Features' ) => array(
--- 175,186 ----
  			'three-columns' => __( 'Three Columns' ),
  			'four-columns'  => __( 'Four Columns' ),
  			'left-sidebar'  => __( 'Left Sidebar' ),
! 			'right-sidebar' => __( 'Right Sidebar' ),
  		),
  
  		__('Width') => array(
  			'fixed-width'    => __( 'Fixed Width' ),
! 			'flexible-width' => __( 'Flexible Width' ),
  		),
  
  		__( 'Features' ) => array(
***************
*** 326,346 ****
  			'sticky-post'           => __( 'Sticky Post' ),
  			'theme-options'         => __( 'Theme Options' ),
  			'threaded-comments'     => __( 'Threaded Comments' ),
! 			'translation-ready'     => __( 'Translation Ready' )
  		),
  
  		__( 'Subject' )  => array(
  			'holiday'       => __( 'Holiday' ),
  			'photoblogging' => __( 'Photoblogging' ),
! 			'seasonal'      => __( 'Seasonal' )
  		)
  	);
  
! 	if ( !current_user_can('install_themes') )
  		return $features;
  
  	if ( !$feature_list = get_site_transient( 'wporg_theme_feature_list' ) )
! 		set_site_transient( 'wporg_theme_feature_list', array( ),  10800);
  
  	if ( !$feature_list ) {
  		$feature_list = themes_api( 'feature_list', array( ) );
--- 201,221 ----
  			'sticky-post'           => __( 'Sticky Post' ),
  			'theme-options'         => __( 'Theme Options' ),
  			'threaded-comments'     => __( 'Threaded Comments' ),
! 			'translation-ready'     => __( 'Translation Ready' ),
  		),
  
  		__( 'Subject' )  => array(
  			'holiday'       => __( 'Holiday' ),
  			'photoblogging' => __( 'Photoblogging' ),
! 			'seasonal'      => __( 'Seasonal' ),
  		)
  	);
  
! 	if ( ! $api || ! current_user_can( 'install_themes' ) )
  		return $features;
  
  	if ( !$feature_list = get_site_transient( 'wporg_theme_feature_list' ) )
! 		set_site_transient( 'wporg_theme_feature_list', array( ), 10800);
  
  	if ( !$feature_list ) {
  		$feature_list = themes_api( 'feature_list', array( ) );
***************
*** 408,422 ****
  	if ( ! $res ) {
  		$request = wp_remote_post('http://api.wordpress.org/themes/info/1.0/', array( 'body' => array('action' => $action, 'request' => serialize($args))) );
  		if ( is_wp_error($request) ) {
! 			$res = new WP_Error('themes_api_failed', __('An Unexpected HTTP Error occurred during the API request.'), $request->get_error_message() );
  		} else {
! 			$res = unserialize( wp_remote_retrieve_body( $request ) );
! 			if ( ! $res )
! 			$res = new WP_Error('themes_api_failed', __('An unknown error occurred.'), wp_remote_retrieve_body( $request ) );
  		}
  	}
! 	//var_dump(array($args, $res));
  	return apply_filters('themes_api_result', $res, $action, $args);
  }
- 
- ?>
--- 283,295 ----
  	if ( ! $res ) {
  		$request = wp_remote_post('http://api.wordpress.org/themes/info/1.0/', array( 'body' => array('action' => $action, 'request' => serialize($args))) );
  		if ( is_wp_error($request) ) {
! 			$res = new WP_Error('themes_api_failed', __( 'An unexpected error occurred. Something may be wrong with WordPress.org or this server&#8217;s configuration. If you continue to have problems, please try the <a href="http://wordpress.org/support/">support forums</a>.' ), $request->get_error_message() );
  		} else {
! 			$res = maybe_unserialize( wp_remote_retrieve_body( $request ) );
! 			if ( ! is_object( $res ) && ! is_array( $res ) )
! 				$res = new WP_Error('themes_api_failed', __( 'An unexpected error occurred. Something may be wrong with WordPress.org or this server&#8217;s configuration. If you continue to have problems, please try the <a href="http://wordpress.org/support/">support forums</a>.' ), wp_remote_retrieve_body( $request ) );
  		}
  	}
! 
  	return apply_filters('themes_api_result', $res, $action, $args);
  }
